<?php 

////////////////////////////////////////////////////////////////////////////////
// Class: SwiftAPI_Request_Unsubscribe
////////////////////////////////////////////////////////////////////////////////


class SwiftAPI_Request_Unsubscribe extends SwiftAPI_Request
	{

	//////////////////////////////////////////////////////////////////////////////
	// Public properties.
	//////////////////////////////////////////////////////////////////////////////

	public $email;


	//////////////////////////////////////////////////////////////////////////////
	// Public functions
	//////////////////////////////////////////////////////////////////////////////

	////////////////////////
	// Public: __construct()
	////////////////////////

	public function __construct($domain, $user, $email, $version = NULL, $date = NULL)
		{
		$this -> email = $email;

		parent::__construct($domain, SwiftAPI::OPERATION_UNSUBSCRIBE, $user, $version, $date);
		}


	///////////////////
	// Public: Create()
	///////////////////

	public static function Create(stdClass $fields)
		{
		parent::Validate($fields);

		if(empty($fields -> email))
			throw new SwiftAPI_Exception('SwiftAPI_Request_Unsubscribe::Create(): "email" field is missing or empty.');

		return new self
			(
			$fields -> domain,
			$fields -> user,
			$fields -> email,
			$fields -> version,
			$fields -> date
			);
		}
	}

?>