<?php

////////////////////////////////////////////////////////////////////////////////
// Class: xml
////////////////////////////////////////////////////////////////////////////////
// Class for quickly generating xml tags
////////////////////////////////////////////////////////////////////////////////
// Examples:
//// xml::br();                                     - Empty <br /> tag.
//// xml::p('hello')                                - Paragraph with content
//// xml::a('click here', array('href' => '/home')) - Anchor with href attribute
////////////////////////////////////////////////////////////////////////////////

class xml
	{

	//////////////////////////////////////////////////////////////////////////////
	// Public methods
	//////////////////////////////////////////////////////////////////////////////

	/////////////////////////
	// Public: __callStatic()
	/////////////////////////

	public static function __callStatic($name, array $args = NULL)
		{
		return self::createElement($name, array_shift($args), array_shift($args));
		}
		
	/**
	* PHP 5.2 support
	*/
	public function __call($name, array $args = NULL) {
		return self::createElement($name, array_shift($args), array_shift($args));
	}

	//////////////////////////////////////////////////////////////////////////////
	// Private methods
	//////////////////////////////////////////////////////////////////////////////

	///////////////////////////
	// Private: createElement()
	///////////////////////////

	private static function createElement($name, $content = NULL, $attributes = NULL)
		{
		$xml = '<' . $name;

		if($attributes)
			{
			if(!is_array($attributes))
				throw new xmlException('xml::createElement() expected array for \'$attributes\' parameter, ' . gettype($attributes) . ' given.');

			foreach($attributes as $attrName => $attrValue)
				$xml .= ' ' . $attrName . '="' . $attrValue . '"';
			}
		
		if(isset($content))
			$xml .= '>' . (is_array($content) ? implode($content) : $content) . '</' . $name . '>';
		else
			$xml .= ' />';

		return $xml;
		}

	}


////////////////////////////////////////////////////////////////////////////////
// Exceptions
////////////////////////////////////////////////////////////////////////////////

class xmlException extends Exception{}

?>
